# Module SElinux
%define module cups_pdf

Summary:        Extension for creating pdf-Files with CUPS
Summary(fr):    Extension de CUPS pour créer des fichiers PDF
Name:           cups-pdf
Version:        2.4.6
Release:        1%{?dist}
Group:          Applications/Publishing
Source0:        http://www.physik.uni-wuerzburg.de/~vrbehr/cups-pdf/src/%{name}_%{version}.tar.gz
Source1:        INSTALL.cups-pdf
Source2:        INSTALL.fedora.cups-pdf
Source3:        %{module}.te
Patch1:         cups-pdf-conf.patch
URL:            http://cip.physik.uni-wuerzburg.de/~vrbehr/cups-pdf/
License:        GPL
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:       ghostscript, cups, policycoreutils
BuildRequires:  selinux-policy-devel, checkpolicy, cups-devel

# These are the defaults paths defined in config.h
# CUPS-PDF spool directory
%define CPSPOOL   %{_localstatedir}/spool/cups-pdf/SPOOL

# CUPS-PDF output directory
%define CPOUT     %{_localstatedir}/spool/cups-pdf

# CUPS-PDF log directory
%define CPLOG     %{_localstatedir}/log/cups

# CUPS-PDF cups-pdf.conf config file
%define ETCCUPS   %(cups-config --serverroot 2>/dev/null || echo %{_sysconfdir}/cups)

# Additional path to backend directory
%define CPBACKEND %(cups-config --serverbin  2>/dev/null || echo %{_libdir}/cups)/backend


%description
"cups-pdf" is a backend script for use with CUPS - the "Common UNIX Printing
System" (see more for CUPS under http://www.cups.org/). 
"cups-pdf" uses the ghostscript pdfwrite device to produce PDF Files.

This version has been modified to store the PDF files on the Desktop of the 
user. This behavior can be changed by editing the configuration file.

%description -l fr
"cups-pdf" est un script de traitement CUPS - le "Common UNIX Printing System"
(plus d'informations sur CUPS à l'adresse http://www.cups.org/). 
"cups-pdf" utilise ghostscript pour construire des fichiers au format PDF.

Cette version a été modifiée pour produire les fichiers PDF sur le bureau
de l'utilisateur (dossier Desktop du répertoire d'accueil de l'utilisateur).
Ce comportement peut être modifié en éditant le fichier de configuration.

%prep
echo CIBLE = %{name}-%{version}-%{release}
%setup -q -n %{name}-%{version}
%{__cp} %{SOURCE1} INSTALL
%{__cp} %{SOURCE2} INSTALL.fedora

# Relocate output on user's Desktop
%patch1 -p0

%build
pushd src
%{__cc} $RPM_OPT_FLAGS -o cups-pdf cups-pdf.c
popd

# SElinux 
%{__mkdir} selinux
pushd selinux
%{__sed} -e s/CUPSVERSION/%{version}/ %{SOURCE3} >%{module}.te
echo "%{CPOUT}   system_u:object_r:print_spool_t:s0"  >%{module}.fc
echo "%{CPSPOOL} system_u:object_r:print_spool_t:s0" >>%{module}.fc
make -f %{_datadir}/selinux/devel/Makefile
popd

# Avoid perl dependencies
%{__chmod} -x contrib/pstitleiconv-0.2/pstitleiconv
%{__chmod} -x contrib/cups-pdf-dispatch-0.1/cups-pdf-dispatch
%{__chmod} -x contrib/SELinux-HOWTO/update-module

%install
rm -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{CPBACKEND}
%{__mkdir_p} %{buildroot}%{CPSPOOL}
%{__mkdir_p} %{buildroot}%{CPOUT}
%{__mkdir_p} %{buildroot}%{CPLOG}
%{__mkdir_p} %{buildroot}%{CPBACKEND}
%{__mkdir_p} %{buildroot}%{ETCCUPS}
%{__mkdir_p} %{buildroot}%{_datadir}/cups/model/
%{__install} -m644 extra/PostscriptColor.ppd %{buildroot}%{_datadir}/cups/model/PostscriptColor.ppd
# %{__gzip} -d %{buildroot}%{_datadir}/cups/model/PostscriptColor.ppd.gz
%{__install} -m644 extra/cups-pdf.conf %{buildroot}%{ETCCUPS}/cups-pdf.conf
%{__install} -m755 src/cups-pdf %{buildroot}%{CPBACKEND}

# SElinux 
%{__mkdir_p} %{buildroot}%{_datadir}/selinux/packages/%{name}
%{__install} -m644 selinux/%{module}.pp %{buildroot}%{_datadir}/selinux/packages/%{name}/%{module}.pp

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc ChangeLog COPYING README INSTALL INSTALL.fedora contrib/
%dir %{CPSPOOL}
%dir %{CPOUT}
%attr(700, root, root) %{CPBACKEND}/cups-pdf
%config(noreplace) %{ETCCUPS}/cups-pdf.conf
%{_datadir}/cups/model/PostscriptColor.ppd
%{_datadir}/selinux/packages/%{name}/%{module}.pp

%post
# Install/update Selinux policy
semodule -i %{_datadir}/selinux/packages/%{name}/%{module}.pp || :
fixfiles -R %{name} restore

# First install : create the printer if cupsd is running
if [ "$1" -eq "1" -a -f "%{_var}/run/cupsd.pid" ]
then
    if [ -d /proc/$(cat %{_var}/run/cupsd.pid) ]
    then
        /usr/sbin/lpadmin -p Cups-PDF -v cups-pdf:/ -m PostscriptColor.ppd -E || :
    fi
fi

%postun
if [ "$1" -eq "0" ]; then
    # Delete the printer
    /usr/sbin/lpadmin -x Cups-PDF || :

    # Remove the SElinux policy.
    semodule -r %{module} || :
fi

%changelog
* Sun May 06 2007 Remi Collet <Fedora@FamilleCollet.com> 2.4.6-1
- update to 2.4.6

* Sun Apr 08 2007 Remi Collet <Fedora@FamilleCollet.com> 2.4.5-1
- update to 2.4.5

* Sat Feb 03 2007 Remi Collet <Fedora@FamilleCollet.com> 2.4.4-1
- update to 2.4.4

* Mon Nov 13 2006 Remi Collet <Fedora@FamilleCollet.com> 2.4.2-2
- review comments (URL, INSTALL.fedora as Source2, descr. rewrap)

* Mon Nov 13 2006 Remi Collet <Fedora@FamilleCollet.com> 2.4.2-1
- clean spec for Extras
- don't use "service cups restart", only test if cups is running

* Tue Oct 24 2006 Remi Collet <rpms@FamilleCollet.com> 2.4.2-1.fc6.remi
- FC6 build

* Sat Oct  7 2006 Remi Collet <rpms@FamilleCollet.com> 2.4.2-1.fc5.remi
- update to 2.4.2

* Tue May 16 2006 Remi Collet <rpms@FamilleCollet.com> 2.4.0-1.fc{3,4,5}.remi
- update to 2.4.0
- add SElinux module
- spec cleanning

* Tue May 16 2006 Remi Collet <rpms@FamilleCollet.com> 2.3.0-1.fc{3,4,5}.remi
- update to 2.3.0
- chmod 700 on %%{CPBACKEND}/cups-pdf for cups-1.2.0 on FC5

* Fri Apr 14 2006 Remi Collet <rpms@FamilleCollet.com> 2.2.0-1.fc{3,4,5}.remi
- update to 2.2.0

* Sat Apr  8 2006 Remi Collet <rpms@FamilleCollet.com> 2.1.1-1.fc{3,4,5}.remi
- update to 2.1.1

* Sun Mar 26 2006 Remi Collet <RPMS@FamilleCollet.com> 2.1.0-1.fc{3,4,5}.remi
- update to 2.1.0

* Sun Jan 29 2006 Remi Collet <RPMS@FamilleCollet.com> 2.0.5-1.fc{3,4}.remi
- update to 2.0.5

* Sun Jan 29 2006 Remi Collet <remi.collet@univ-reims.fr> 2.0.4-1.fc{3,4}.remi
- update to 2.0.4

* Sat Jan  7 2006 Remi Collet <remi.collet@univ-reims.fr> 2.0.3-1.fc{3,4}.remi
- update to 2.0.3

* Wed Jan  4 2006 Remi Collet <remi.collet@univ-reims.fr> 2.0.1-1.fc{3,4}.remi
- update to 2.0.1

* Tue Jan  3 2006 Remi Collet <remi.collet@univ-reims.fr> 2.0.0-2.fc#.remi
- output to Desktop
- defattr

* Fri Dec 23 2005 Remi Collet <remi.collet@univ-reims.fr> 2.0.0-1.fc4.remi
- update to 2.0.0 final

* Sat Nov  5 2005 Remi Collet <remi.collet@univ-reims.fr> 2.0-0.1.fc3.remi
- rebuild for FC3

* Sat Nov  5 2005 Remi Collet <remi.collet@univ-reims.fr> 2.0-0.1.fc4.remi
- update to 2.0 beta2
- rebuild for FC4
- conditionnal "post" and "postun" script, more robust
- cups-pdf-conf.patch (Out in $HOME)

* Mon Sep 26 2005 Christian Ellsworth C. <k.ellsworth@gmail.com>
- adapted to fit the new runtime config file of version 2.0

* Sat Sep 10 2005 Remi Collet <remi.collet@univ-reims.fr> 1.7.4-1.fc4.remi
- adapted to cups-pdf 1.7.4
- added auto remove a cups-pdf printer in "postun"
- added CHANGELOG, COPYING, README
- creating cups-pdf-home.patch

* Sat Mar 05 2005 Christian Ellsworth C. <k.ellsworth@gmail.com>
- adapted to cups-pdf 1.7.0
- added auto configure a cups-pdf printer

* Tue Feb 22 2005 Christian Ellsworth C. <k.ellsworth@gmail.com>
- adapted to cups-pdf 1.6.6

* Thu Aug 12 2004 Volker Behr <vrbehr@cip.physik.uni-wuerzburg.de>
- adapted to cups-pdf 1.5.2 

* Sat Jan 31 2004 Volker Behr <vrbehr@cip.physik.uni-wuerzburg.de>
- adapetd to cups-pdf 1.4.0 and new building environment

* Wed Jan 14 2004 Mark Lane <harddata.com>
- fixed the specfile so that x86_64 version installs the filter
- in /usr/lib64 instead of /usr/lib

* Sun Nov 02 2003 Volker Behr <vrbehr@cip.physik.uni-wuerzburg.de>
- third release of cups-pdf, RPM-Edition for cups-pdf 1.3

* Tue Sep 09 2003 Dirk Schwier <rpms@raumhochdrei.de>
- second Release of cups-pdf, RPM-Edition for cups-pdf 1.1

* Tue May 27 2003 Dirk Schwier <rpms@raumhochdrei.de>
- we're proud to present the first version of cups-pdf, RPM-Edition
